Difference between revisions of "Mesh to Part/de"

From FreeCAD Documentation
Jump to navigation Jump to search
Line 20: Line 20:
 
Mesh.show(m)
 
Mesh.show(m)
 
}}
 
}}
Manchmal ist die Triangulation bestimmter Flächen, die OpenCascade anbietet, ziemlich hässlich. Wenn die Fläche einen rechteckigen Parameterraum hat und keine Löcher oder andere Beschnittkurven enthält, kannst Du auch selbst ein Netz erstellen:
+
Manchmal ist die Triangulation bestimmter Flächen, die OpenCascade anbietet, ziemlich hässlich. Wenn die Fläche einen rechteckigen Parameterraum hat und keine Löcher oder andere Beschnittkurven enthält, kannst Du auch selbst ein Drahtmodel (mesh) erstellen:
 
{{Code|code=
 
{{Code|code=
 
import Mesh
 
import Mesh

Revision as of 06:01, 4 January 2020

Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎română • ‎svenska • ‎čeština • ‎русский • ‎日本語

Konvertieren von Bauteilobjekten in Drahtmodelle (mesh)

Die Konvertierung von übergeordneten Objekten wie Teilformen in einfachere Objekte wie Drahtmodelle (mesh) ist eine sehr einfache Operation, bei der alle Flächen eines Teilobjekts trianguliert werden. Das Ergebnis dieser Triangulation (Tesselierung) wird dann zum Aufbau eines Drahtmodells (mesh) verwendet: (nehmen wir an, unser Dokument enthält ein Teilobjekt)

#let's assume our document contains one part object
import Mesh
faces = []
shape = FreeCAD.ActiveDocument.ActiveObject.Shape
triangles = shape.tessellate(1) # the number represents the precision of the tessellation)
for tri in triangles[1]:
    face = []
    for i in range(3):
        vindex = tri[i]
        face.append(triangles[0][vindex])
    faces.append(face)
m = Mesh.Mesh(faces)
Mesh.show(m)

Manchmal ist die Triangulation bestimmter Flächen, die OpenCascade anbietet, ziemlich hässlich. Wenn die Fläche einen rechteckigen Parameterraum hat und keine Löcher oder andere Beschnittkurven enthält, kannst Du auch selbst ein Drahtmodel (mesh) erstellen:

import Mesh
def makeMeshFromFace(u,v,face):
	(a,b,c,d)=face.ParameterRange
	pts=[]
	for j in range(v):
		for i in range(u):
			s=1.0/(u-1)*(i*b+(u-1-i)*a)
			t=1.0/(v-1)*(j*d+(v-1-j)*c)
			pts.append(face.valueAt(s,t))

	mesh=Mesh.Mesh()
	for j in range(v-1):
		for i in range(u-1):
			mesh.addFacet(pts[u*j+i],pts[u*j+i+1],pts[u*(j+1)+i])
			mesh.addFacet(pts[u*(j+1)+i],pts[u*j+i+1],pts[u*(j+1)+i+1])

	return mesh

Konvertieren von Netzen in Bauteilobjekte

Die Umwandlung von Netzen in Bauteilobjekte ist ein äußerst wichtiger Vorgang in der CAD Arbeit, da man sehr oft 3D Daten im Mesh Format von anderen Personen erhält oder diese aus anderen Anwendungen ausgegeben werden. Netze sind sehr praktisch, um Freiformgeometrien und große visuelle Szenen darzustellen, da sie sehr leicht sind, aber für CAD bevorzugen wir im Allgemeinen übergeordnete Objekte, die viel mehr Informationen enthalten, wie z.B. die Idee des Solid oder Flächen aus Kurven statt Dreiecken.

Die Konvertierung von Netzen in diese übergeordneten Objekte (die vom Part Module/de in FreeCAD verwaltet werden) ist keine leichte Aufgabe. Netze können aus Tausenden von Dreiecken bestehen (z.B. wenn sie von einem 3D Scanner erzeugt werden), und Körper mit derselben Anzahl von Flächen zu haben, wäre extrem schwer zu manipulieren. Daher ist es in der Regel sinnvoll, das Objekt bei der Konvertierung zu optimieren.

FreeCAD bietet derzeit zwei Möglichkeiten, Netze in Bauteilobjekte zu konvertieren. Die erste Methode ist eine einfache, direkte Umwandlung, ohne jegliche Optimierung:

import Mesh,Part
mesh = Mesh.createTorus()
shape = Part.Shape()
shape.makeShapeFromMesh(mesh.Topology,0.05) # the second arg is the tolerance for sewing
solid = Part.makeSolid(shape)
Part.show(solid)

Die zweite Methode bietet die Möglichkeit, Netzfacetten koplanar zu betrachten, wenn der Winkel zwischen ihnen unter einem bestimmten Wert liegt. Dies ermöglicht es, viel einfachere Formen zu bauen: (nehmen wir an, unser Dokument enthält ein Mesh Objekt).

# let's assume our document contains one Mesh object
import Mesh,Part,MeshPart
faces = []
mesh = App.ActiveDocument.ActiveObject.Mesh
segments = mesh.getPlanes(0.00001) # use rather strict tolerance here
 
for i in segments:
  if len(i) > 0:
     # a segment can have inner holes
     wires = MeshPart.wireFromSegment(mesh, i)
     # we assume that the exterior boundary is that one with the biggest bounding box
     if len(wires) > 0:
        ext=None
        max_length=0
        for i in wires:
           if i.BoundBox.DiagonalLength > max_length:
              max_length = i.BoundBox.DiagonalLength
              ext = i

        wires.remove(ext)
        # all interior wires mark a hole and must reverse their orientation, otherwise Part.Face fails
        for i in wires:
           i.reverse()

        # make sure that the exterior wires comes as first in the list
        wires.insert(0, ext)
        faces.append(Part.Face(wires))

shell=Part.Compound(faces)
Part.show(shell)
#solid = Part.Solid(Part.Shell(faces))
#Part.show(solid)